﻿var lightRGB = longHexToDec(preferences.lightColor.value);
var darkRGB=  longHexToDec(preferences.darkColor.value);
var baseColor = preferences.baseColor.value;
var colorValues = new Array();
var colorHistory = new Array();
var cHistoryY = 160;
var cHistoryX = 120;
var nHistoryObj = new Array();
var activeHistory = 0;
var historyIndex = 0;

function init() {
	initSwatches();
	baseColorField.data = baseColor;
	lightColorField.data = preferences.lightColor.value;
	darkColorField.data = preferences.darkColor.value;
	createColorHistory();
	createSwatches();
}


function initSwatches() {
	var color = new Array("A74661","BD7589","D4A3B1","E9D1D7","F7EDF0","8E3C52","7D3549","542331","2A1218","11070A");
	var x=25;var y=19; var cp = new Array();
	for(i=0;i<color.length;i++) {
		obj = eval("cpc"+i);
		obj.width = "75";
		obj.height = "30";
		//obj.bgColor = "#" + color[i];
		obj.bgOpacity = "255";
		obj.hOffset = x;
		obj.vOffset =y;
		obj.tooltip = color[i];
		y+=35;
	
	}
}

function createColorHistory() {
	colorHistory = preferences.colorHistory.value.split(",");
	for(i=0;i<colorHistory.length;i++) {
		if(colorHistory[i]) {
			createHistoryObject(colorHistory[i]);
			historyIndex++;
		}
	}
}

function isHex(hex) {
	if(hex.length!=6)return false;
	exp = new RegExp(/[a-f0-9]/gi);
	h=hex.match(exp,hex);
	if(h.length==6) {
		return true;
	} else {
		return false;
	}
}

function setColorHue(originColor,opacityPercent,maskRGB) {
	returnColor=new Array();
	for(w=0;w<originColor.length;w++) returnColor[w] = Math.round(originColor[w]*opacityPercent) + Math.round(maskRGB[w]*(1.0-opacityPercent));
	return returnColor;
}

function longHexToDec(longHex) {
	r=toDec(longHex.substring(0,2));
	g=toDec(longHex.substring(2,4));
	b=toDec(longHex.substring(4,6));
	return new Array(r,g,b);
}

function toHex(dec) {
	hex=dec.toString(16);
	if(hex.length==1)hex="0"+hex;
	if(hex==100)hex="FF";
	return hex.toUpperCase();
}

function toDec(hex) {
	return parseInt(hex,16);
}

function randomBaseColor() {
	r=toHex(Math.floor(Math.random() * 255));
	g=toHex(Math.floor(Math.random() * 255));
	b=toHex(Math.floor(Math.random() * 255));

	baseColorField.data = r+g+b;
	createSwatches();
}

function isInHistory(color) {
	for(i=0;i<colorHistory.length;i++) if(colorHistory[i] == color) return true;
	return false;
}

function createSwatches() {
	nHex=baseColorField.data;
	if(!isHex(nHex))return alert("Please enter a valid six character hex value.");
	preferences.baseColor.value = nHex;

	if(!isInHistory(nHex)) {
		colorHistory[historyIndex] = baseColorField.data;
		historyIndex++;
		createHistoryObject(nHex);
	}
	baseColor = longHexToDec(nHex);
	opArray=new Array(1.0,.75,.50,.25,.10,.85,.75,.50,.25,.10);
	for(i=0;i<10;i++) {
		nMask = i<5?lightRGB:darkRGB;
		nColor=setColorHue(baseColor,opArray[i],nMask);
		nHex = toHex(nColor[0])+toHex(nColor[1])+toHex(nColor[2]);
		colorValues[i]=new Array();
		colorValues[i][0] = nHex;
		colorValues[i][1] = nColor;

		obj = eval("cpc" + i);
		obj.bgColor = "#"+nHex;
		obj.tooltip = nHex;
	}
}

function newBaseFromHistory(color) {
	baseColorField.data = color;
	createSwatches();
}

function createHistoryObject(color) {
	k = nHistoryObj.length;
	nHistoryObj[k] = new Text();
	nHistoryObj[k].width="10";
	nHistoryObj[k].height="10";
	nHistoryObj[k].bgOpacity="255";
	nHistoryObj[k].bgColor = "#" + color;
	nHistoryObj[k].vOffset = cHistoryY;
	nHistoryObj[k].hOffset = cHistoryX;
	nHistoryObj[k].tooltip = color;
	nHistoryObj[k].onMouseDown = "newBaseFromHistory(\""+color+"\")";

	cHistoryX+=12;
	if(cHistoryX>=340) {
		cHistoryX = 120;
		cHistoryY+=12;
	}

	if(historyIndex==114) {
		historyIndex = 0;
		//colorHistory = new Array();
		cHistoryX = 120;
		cHistoryY = 160;
	}

	preferences.colorHistory.value = colorHistory;
}

function clearColorHistory() {
	preferences.colorHistory.value = "";
	colorHistory = new Array();
	historyIndex = 0;
	cHistoryY = 160;
	cHistoryX = 120;

	for(i=0;i<nHistoryObj.length;i++) {
		obj = nHistoryObj[i];
		delete obj;
	}
	nHistoryObj = new Array();
	createHistoryObject(cpc0.tooltip);
}
init();